\chapter{Evaluation}
\label{evaluation}
To evaluate our approaches we used two different types of assessment. The first one is based on statistics and shows the quantity of synonyms that can be retrieved using our methods. The second one is a qualitative evaluation, that judges our methods against a ground truth. In the first section, we describe the statistical evaluation. In the second one, we show how we built our ground truth. In the third one, we present the qualitative assessment. 
\section{Looking at the Numbers}
\label{evaluation:statistics}
To have an idea of how many synonyms we get in general, not considering whether they are actually right or wrong, we calculate their distribution for each of the previously mentioned approaches.\\
As a quick summary, here follow the names:
\begin{enumerate}
	\item \unsyn 
	\item \unsynsim
	\item \unsynsyn 
	\item \unsynsynsim 
	\item \spacya 
	\item \spacyone 
	\item \spacytwo
	\item \spacyinter
	\item \spacydocs
\end{enumerate}
To have an initial evaluation of the number of synonyms retrieved for each approach we asked ourselves the question \emph{how often do we get how many?}.\\
\autoref{stats1} shows how many synonyms we get for the lexical approach. Even though the maximum number of synonyms retrieved by the \unsynsynsim approach is 143, we cut the plot at 60 synonyms, because after that only few adjectives have higher numbers.\\
Many of the adjectives have up to 30 synonyms in at least one of the approaches, but still many more have five or less synonyms. For the \unsynsynsim method, the adjectives that capture five or less synonyms are three times more than the ones that capture more.
\begin{figure}
\centering
\begin{tikzpicture}[yscale=\sizegraph, xscale=\sizegraph]
\begin{axis}[
xlabel=$How Many Synonyms?$,
ylabel=$How Often?$, 
cycle list name=exotic,
ylabel near ticks,
width=\textwidth,
height=9cm,
xmin=0,
xmax=60,
ymin=0,
ymax=1000]
\addplot +[mark size=0.65] file{Data/totalcountopt0.txt};
\addlegendentry{\unsyn}

\addplot +[mark size=0.65] file{Data/totalcountopt1.txt};
\addlegendentry{\unsynsim}

\addplot +[mark size=0.65] file{Data/totalcountopt2.txt};
\addlegendentry{\unsynsyn}

\addplot +[mark size=0.65] file{Data/totalcountopt3.txt};
\addlegendentry{\unsynsynsim}
\end{axis}
\end{tikzpicture}
\caption{Distribution of synonyms for the \wordnet approaches.}
\label{stats1}
\end{figure}

Similarly, in \autoref{stats2} it is possible to see the number of synonyms for the word-vector approaches. In the same way we cut the plot at 300, even though the \spacydocs approach retrieved up to 1160 synonyms and the \spacytwo approach retrieved up to 1030 for some features. Here, all approaches but two have very often 20 synonyms. The other two, instead, have less but distributed more homogeneously.

\begin{figure}
\centering
\begin{tikzpicture}[yscale=\sizegraph, xscale=\sizegraph]
\begin{axis}[
xlabel=$How Many Synonyms?$,
ylabel=$How Often?$, 
cycle list name=exotic,
ylabel near ticks,
width=\textwidth,
height=9cm,
xmin=0,
xmax=300,
ymin=0,
ymax=1000]
\addplot +[mark size=0.65] file{Data/totalcountopt4.txt};
\addlegendentry{\spacya}

\addplot +[mark size=0.65] file{Data/totalcountopt5.txt};
\addlegendentry{\spacyone}

\addplot +[mark size=0.65] file{Data/totalcountopt6.txt};
\addlegendentry{\spacytwo}

\addplot +[mark size=0.65] file{Data/totalcountopt7.txt};
\addlegendentry{SpacyInter}

\addplot +[mark size=0.65] file{Data/totalcountopt8.txt};
\addlegendentry{SpacyDocs}
\end{axis}
\end{tikzpicture}
\caption{Distribution of synonyms for the \spacy approaches.}
\label{stats2}
\end{figure}

Let us now have a look at the distribution of synonyms for one of the most common features: breakfast. In \autoref{statsbreak3} it is possible to see the \unsynsynsim, \spacytwo and \spacydocs approaches. We choose to show these ones because they are the ones with the most significant results over the whole set of adjectives.\\
The \wordnet approach retrieves up to 50 synonyms, and the \emph{\spacytwo} collects many adjectives but not very often. On the contrary, \emph{\spacydocs} collects many between 0 and 250. The maximum number for the two word-vector methods is around 650.
\begin{figure}
\centering
\begin{tikzpicture}[yscale=\sizegraph, xscale=\sizegraph]
\begin{axis}[
xlabel=$How Many Synonyms?$,
ylabel=$How Often?$, 
cycle list name=exotic,
ylabel near ticks,
width=\textwidth,
height=9cm,
xmin=0,
xmax=400,
ymin=0,
ymax=1000]
\addplot +[mark size=0.65] file{Data/countbreakfastopt3.txt};
\addlegendentry{\unsynsynsim}

\addplot +[mark size=0.65] file{Data/countbreakfastopt6.txt};
\addlegendentry{\spacytwo}

\addplot +[mark size=0.65] file{Data/totalcountopt8.txt};
\addlegendentry{\spacydocs}
\end{axis}
\end{tikzpicture}
\caption{A comparison of the approaches with the most synonyms from the two categories for the feature \emph{breakfast}.}
\label{statsbreak3}
\end{figure}

As a summary, \autoref{table:avgs1} and \autoref{table:avgs2} contain the averages for the different methods. The results confirm what we saw in the plots: \wordnet retrieves many time times a low number of synonyms, while \spacy finds many more. 

\begin{table}[b]
	\centering
	\begin{minipage}{\textwidth}
	\caption{Average of synonyms for the \wordnet methods.}
	\label{table:avgs1}
	\centering
	\begin{tabular}{c c c c c}
		\toprule
		\textbf{Method} & \multicolumn{1}{c}{\unsyn} & \multicolumn{1}{c}{\unsynsim} & \multicolumn{1}{c}{\unsynsyn} & \multicolumn{1}{c}{\unsynsynsim} \\
		\midrule
		\textbf{Average} & 0.51 & 1.47 & 1.12  & 2.77 \\
		\bottomrule
	\end{tabular}
	\end{minipage}\\
	\vspace{1.25em}
	\begin{minipage}{\textwidth}
	\caption{Average of synonyms for the \spacy methods.}
	\label{table:avgs2}
	\centering
	\begin{tabular}{c c c c c c}
	\toprule
	\textbf{Method} & \multicolumn{1}{c}{\spacya} & \multicolumn{1}{c}{\spacyone} & \multicolumn{1}{c}{\spacytwo} & \multicolumn{1}{c}{\spacyinter}& \multicolumn{1}{c}{\spacydocs}\\
	\midrule
	\textbf{Average} & 0.90 & 0.37 & 68.54  & 0.003 & 71.06 \\
	\bottomrule
	\end{tabular}
	\end{minipage}
\end{table}

This is also shown by the weighted average. \autoref{table:wavgs1} and \autoref{table:wavgs2} answer to the question \emph{what is the expected number of synonyms?} Here we compute the average weighted by the frequency of the original adjective. The results are not very different from before and they confirm what has been previously said.

\begin{table}[b]\centering
	\begin{minipage}{\textwidth}
	\caption{Weighted average of synonyms for the \wordnet methods.}
	\label{table:wavgs1}
	\centering
	\begin{tabular}{c c c c c}
		\toprule
		\textbf{Method} & \multicolumn{1}{c}{\unsyn} & \multicolumn{1}{c}{\unsynsim} & \multicolumn{1}{c}{\unsynsyn} & \multicolumn{1}{c}{\unsynsynsim} \\
		\midrule
		\textbf{Weighted Average} & 0.85 & 2.46 & 1.78  & 4.40 \\
		\bottomrule
	\end{tabular}
	\end{minipage}\\
	\vspace{1.25em}
	\begin{minipage}{\textwidth}
	\caption{Weighted average of synonyms for the \spacy methods.}
	\label{table:wavgs2}
	\centering
	\begin{tabular}{c c c c c c}
		\toprule
		\textbf{Method} & \multicolumn{1}{c}{\spacya} & \multicolumn{1}{c}{\spacyone} & \multicolumn{1}{c}{\spacytwo} & \multicolumn{1}{c}{\spacyinter}& \multicolumn{1}{c}{\spacydocs}\\
		\midrule
		\textbf{Weighted Average} & 1.63 & 0.55 & 81.06  & 0.009 & 84.57 \\
		\bottomrule
	\end{tabular}
	\end{minipage}
\end{table}

\section{Building the Ground Truth}
The intuition for building the ground truth is to ask some authority if two words are synonyms or not, so that we can calculate measures such as precision and recall. However, such authority does not exist, especially when considering context. A second idea was that we ourselves could be the judges, but we did not think that our perception alone was a good enough motivation. Thus, we decided to create a survey and gather participants, so that the average of their opinions could be our judge.\\
Our first aim was to assess the quality of the similarity triples retrieved. Thus, we thought about how many questions could be useful, without asking too many to a single participant. We reasoned that 100 questions, if very simple, could be a good compromise. In fact, by choosing the five most common features, we could question the participants over 20 pairs of adjectives each.\\
The process of choosing the pairs worked as follows in the next lines. We consider \emph{frequent adjectives} for a feature \emph{F} all adjectives that belong to the first half of the list of $adjectives \in F$ in descending order of frequency. We consider \emph{infrequent adjectives} the ones belonging to the second half of the list. Both sets are interesting for our research; in fact we would like to expand from a frequent term to another frequent term, so that we can gather more reviews and more opinions, but also from a frequent term to an infrequent term, so that we can retrieve reviews we would not have searched for otherwise.
\begin{itemize}
	\item For each feature, 10 pairs of adjectives were chosen randomly.
	\item For each feature, 15 pairs of related frequent adjectives were chosen by us.
	\item For each feature, 15 pairs of related infrequent adjectives were chosen by us.
\end{itemize}
This procedure was repeated two times. After that, we had two documents for a total of 400 pairs of adjectives.\\
In addition to the frequent and infrequent pairs, we thought it was a good idea to add some randomness. However, not many of them were interesting and the ones, which were interesting, were translated into the frequent/infrequent scheme.\\
Ideally we wanted half of the pairs to be labeled as related and half of them as unrelated, so that we could test both the precision and the recall of our system. Thus, we passed the set through our methods.
Afterwards we chose the most interesting 100 out of 400, dividing them first into \emph{retrieved and interesting} and \emph{not retrieved but interesting}. The choice was made for trying to keep them half retrieved, half not retrieved, half frequent, half infrequent.\\
During this process a question emerged: \emph{is similarity symmetric?} We could not answer the question ourselves, especially because some adjectives can include some others, but the contrary might not be true. An example is that a clean room is a good room, but a good room is not always a clean room. So we decided to have two different versions of the survey: one with the chosen pairs and one with their symmetric version.\\
All question were of the form \emph{Do you think that competent staff is similar to exceptional staff?} and the participants were asked to rate the similarity in a Likert scale from one to five. We chose this type of answer because its result can be assessed with different thresholds.\\

A second interesting assessment was about the performance of word-vector on scaling adjectives. The participants were asked which scale out of two was the one describing one particular adjective best. One scale was created by \sentiwordnet with the approach described in \autoref{intensities:sentiwordnet}, the other one with \wordvec with the approach described in \autoref{intensities:word2vec}. However, we had to resize the scales to make them of the same size, so that participants could compare them better. This was done by cutting the larger scale by selecting the closer adjectives to the queried one.\\
Since we had two versions of the survey, we decided to use different \emph{seed words} (we picked \textit{decent} and \textit{good}) for the second approach, but the same adjectives.\\
In the end, the survey was composed of three parts:
\begin{itemize}
	\item A section regarding information about the participant (age and sex).
	\item A second part with ten question on the comparison between the \sentiwordnet and the \wordvec scales.
	\item 100 question for adjective comparison.
\end{itemize}

\section{Comparing the Results}

\label{evaluation:comparison}
For our survey we managed to collect 40 participants: 21 for the former questionnaire, 19 for the latter.\\
Regarding the comparison of the scales, the participants did not find one scale significantly better than the other. In fact, the result showed that the scales are hardly of any difference. In \autoref{pie1} you can see the results for this type of question for the adjective \emph{tasty}. The scale of adjectives for \sentiwordnet is:
\begin{center}
	\scale{tasteless, puerile, watery, tasty, scrumptious, yummy, delectable}
\end{center}
The scale for \wordvec in questionnaire 1 is:
\begin{center}
	\scale{nightmarish, horrifying, vile, appetizing, tasty, yummy, delicious}
\end{center}
The scale for \wordvec in questionnaire 2 is:
\begin{center}
	\scale{nightmarish, gruesome, tasteless, appetizing, delicious, tasty, delectable}
\end{center}
\begin{figure}
\centering
\begin{subfigure}{0.48\textwidth}
\begin{tikzpicture}[yscale=0.5, xscale=0.5]
\pie [color={green, yellow},
/tikz/every pin/.style={align=center},
text=legend]{42.1/\sentiwordnet,57.9/\wordvec}
\end{tikzpicture}
\subcaption{Result for questionnaire 1}
\label{pie1:1}
\end{subfigure}
\begin{subfigure}{0.48\textwidth}
\begin{tikzpicture}[yscale=0.5, xscale=0.5]
\pie [color={green, yellow},
/tikz/every pin/.style={align=center},
text=legend]{47.6/\sentiwordnet, 52.4/\wordvec}
\end{tikzpicture}
\subcaption{Result for questionnaire 2}
\label{pie1:2}
\end{subfigure}
\caption{Result of users' preference over the \emphq{tasty} scale.}
\label{pie1}
\end{figure}

In this case, the participants slightly preferred the \wordvec approach. However, the average for \sentiwordnet in questionnaire one is 52\% and in questionnaire two is 48\%, which gives 50\% when averaging the two questionnaires.\\
This results shows how, given a reference scale, \wordvec can mimic the relations between the words given by \sentiwordnet, so that humans cannot have a strong opinion on which one is better.
\vspace{0.5em}

The answers given by the participants for the synonym questions are on a scale from 1 to 5. To access them, we compute the average for each question, and we check first how many out of the 200 given pairs are considered synonyms using different thresholds. To make it more precise, we set as constraint that $average \ge threshold$ and $variance \leq 1.5$. We choose to take into account the variance because some pairs might have an average of 4, but some people might still have rated them as 1s. We think that the value $1.5$ can reduce this problem without setting too strict constraints. The problem of the variance shows how people evaluate the similarity between two adjectives differently, even if a context is given, and shows why this research is important. The results are summed up in \autoref{table:thresholds}. Out of those, we chose to use a threshold of 3.5 because this number is above average but not too strict.

\begin{table}[b]
	\centering
	\caption{Pairs considered synonyms by the users using different thresholds for similarity. In the first line, setting only $average \ge threshold$. In the second line, $average \ge threshold$ and $variance \leq$ 1.5.}
	\label{table:thresholds}
	\begin{tabular}{c c c c c c}
		\toprule
		\textbf{Threshold} & \multicolumn{1}{c}{2.5} & \multicolumn{1}{c}{3.0} & \multicolumn{1}{c}{3.5} & \multicolumn{1}{c}{4.0}& \multicolumn{1}{c}{4.5}\\
		\midrule
		\textbf{N. Synonyms (no variance)} & 174/200 & 140/200  & 90/200 & 52/200 & 12/200\\
		\textbf{N. Synonyms (with variance)} & 140/200 & 116/200  & 77/200 & 49/200 & 12/200\\
		\bottomrule
	\end{tabular}
\end{table}
As explained by Manning \citeal{Manning2008}, in order to access the \emph{effectiveness} (i.e. the quality of the results) of our system we need some measures. These measures are called \emph{precision}, \emph{recall} and \emph{F-score}.
To compute these measures, we need first some definitions:
\begin{itemize}
	\item True Positive: an instance retrieved by the system and considered correct by the ground truth. 
	\item False Positive: an instance retrieved by the system and considered wrong by the ground truth.
	\item True Negatives: an instance not retrieved by the system and considered wrong by the ground truth.
	\item False Negatives: an instance not retrieved by the system and considered correct by the ground truth.
\end{itemize}
Ideally, we would have only true positives and true negatives. The precision is defined as the fraction of relevant instances among the retrieved instances (\autoref{eqprec}). A document is relevant if a user perceives the contained information of value. 
\begin{linenomath*}
	\begin{ceqn}
		\begin{align}
		\label{eqprec}
		Precision = \frac{True Positives}{True Positives + False Positives} 
		\end{align}
	\end{ceqn}
\end{linenomath*}
The recall is defined as the fraction between the number of correct positive results and the number of all relevant samples (\autoref{eqrec}).
\begin{linenomath*}
	\begin{ceqn}
		\begin{align}
		\label{eqrec}
		Recall = \frac{True Positives}{True Positives + False Negatives} 
		\end{align}
	\end{ceqn}
\end{linenomath*}
The F-score is the harmonic mean of precision and recall and can show very neatly how a method performs.
\begin{linenomath*}
	\begin{ceqn}
		\begin{align}
		\label{eqfmeasure}
		F-score = 2 \cdot \frac{Precision \cdot Recall}{Precision + Recall} 
		\end{align}
	\end{ceqn}
\end{linenomath*}

For all these measures, their best value is one and their worst value is zero.\\
We now present a table showing the results of our similarity methods, taking the variance into account and not doing so. The results with the variance constraint are in brackets. In \autoref{table:synsresult1} we can see the results for the \wordnet methods and in \autoref{table:synsresult2} the results for the \spacy methods. This shows that the methods that in general collect more synonyms are also the ones performing better on the ground truth. Others have a quite high precision, but do not retrieve many synonyms in general. This can be deducted by the fact that the recall is quite low: it means that the number of false negatives is quite high. The \spacyinter method does not retrieve any synonyms, which means that the intersection of the two sets of synonyms of feature and adjective is not a good approach. Comparing the \unsynsyn and the \unsynsynsim approaches, we notice that the first one does not retrieve many and is also not precise, unlike the second one, although it is just an extension of the first one. We can deduct that expanding with the \emphq{similar to} attributes yields more synonyms, while doing so with the synsets creates a too wide distance between the retrieved words and the original adjective. It is easy to see that the \spacytwo and the \spacydocs methods are the ones that perform best, which means that word vectors produce better results when taking into account the context of the feature

\begin{table}[b]
	\centering
	\begin{minipage}{\textwidth}
	\caption{Pairs considered synonyms by the users using the \wordnet methods using 3.5 as a threshold.}
	\label{table:synsresult1}
	\centering
	\begin{tabular}{c c c c c}
		\toprule
		\textbf{Method} & \multicolumn{1}{c}{\unsyn} & \multicolumn{1}{c}{\unsynsim} & \multicolumn{1}{c}{\unsynsyn} & \multicolumn{1}{c}{\unsynsynsim}\\
		\midrule
		\multirow{2}{*}{\textbf{Precision}}& 0.5 & 0.89 & 0.25 & 0.69 \\
		& \variance{0.5} & \variance{0.89} & \variance{0.25} & \variance{0.69} \vspace{0.3em}\\
		
		\multirow{2}{*}{\textbf{Recall}} & 0.02 & 0.18 & 0.02 & 0.2 \\
		& \variance{0.03} & \variance{0.21} & \variance{0.03} & \variance{0.23} \vspace{0.3em}\\
		
		\multirow{2}{*}{\textbf{F-Score}} & 0.04 & 0.3 & 0.04 & 0.31 \\
		& \variance{0.05} & \variance{0.34} & \variance{0.05} & \variance{0.35} \\
		\bottomrule
	\end{tabular}
	\end{minipage}\\
	\vspace{1.25em}
	\begin{minipage}{\textwidth}
	\caption{Pairs considered synonyms by the users using the \spacy methods using 3.5 as a threshold and 0.7 as cosine similarity threshold.}
	\label{table:synsresult2}
	\centering
	\begin{tabular}{c c c c c c}
		\toprule
		\textbf{Method} & \multicolumn{1}{c}{\spacya} & \multicolumn{1}{c}{\spacyone} & \multicolumn{1}{c}{\spacytwo} & \multicolumn{1}{c}{\spacyinter} & \multicolumn{1}{c}{\spacydocs}\\
		\midrule
		\multirow{2}{*}{\textbf{Precision}} & 0.89 & 0.83 & 0.49 & 0 & 0.48 \\
		& \variance{0.83} & \variance{0.83} & \variance{0.42} & \variance{0} & \variance{0.41}  \vspace{0.3em}\\
		
		\multirow{2}{*}{\textbf{Recall}} & 0.18 & 0.11 & 0.96 & 0 & 0.93 \\
		& \variance{0.19} & \variance{0.13} & \variance{0.96} & \variance{0} & \variance{0.94}  \vspace{0.3em}\\ 
		
		\multirow{2}{*}{\textbf{F-Score}}  & 0.3 & 0.2 & 0.64 & 0 & 0.63 \\
		& \variance{0.32} & \variance{0.22} & \variance{0.58} & \variance{0} & \variance{0.57} \\
		\bottomrule
	\end{tabular}
	\end{minipage}
\end{table}

From the beginning we assumed that the best threshold was 0.7 and now we are going to give a reason by looking at a table containing precision, recall and F-score for the two \spacy approaches with the highest values (\autoref{table:synsresultt}). We are going to show only the results considering the variance, since the distribution is the same in both cases.
\begin{table}[b]
	\centering
	\caption{Values of Precision, Recall and F-score for different thresholds for the methods with the highest number of synonyms (\spacytwo and \spacydocs).}
	\label{table:synsresultt}
	\begin{tabular}{c c c c c c c c c}
		\toprule
		\multirow{2}{*}{\textbf{Threshold}} &$\quad$& \multicolumn{3}{c}{\spacytwo} &$\quad$& \multicolumn{3}{c}{\spacydocs}\\ 
		\cmidrule{3-5}
		\cmidrule{7-9}
		&& Precision & Recall & F-score && Precision & Recall & F-score\\ 
		\midrule
		0.5 && 0.39 & 0.99 & 0.56 && 0.39 & 0.99 & 0.56 \\
		0.6 && 0.39 & 0.99 & 0.56 && 0.39 & 0.99 & 0.56 \\
		0.7 && 0.42 & 0.96 & 0.58 && 0.41 & 0.94 & 0.57 \\
		0.8 && 0.51 & 0.66 & 0.58 && 0.49 & 0.64 & 0.55 \\
		0.9 && 0.75 & 0.23 & 0.36 && 0.75 & 0.23 & 0.36 \\
		\bottomrule
	\end{tabular}
\end{table}

In the table is possible to see how the number of synonyms retrieved by the two approaches for thresholds 0.5 and 0.6 are the same, which means that for this set of adjectives there are many with $0.5 \leq cos(\theta) \leq 0.6$. For 0.7, we get a bit more precision and a bit less recall: the number of synonyms retrieved is slightly less than before, more are categorised as false negatives and less as false positives. For threshold 0.8 the ratio changes very much for both approaches. In fact, the number of relevant instances, which were captured before with lower thresholds, are now false negatives. For 0.9 not many are retrieved; we can assume that is quite unlikely for word vectors to have such a high cosine similarity.
We choose 0.7 as threshold because it is not too strict but still is reasonable to assume that a cosine of 0.7 yields similar results. Furthermore, it is the one for which we obtain the best results.
\vspace{0.5em}

The only still open assessment is symmetry. We handed out two different versions of the synonyms so that we could test if humans think that similarity is symmetric. To test for symmetry we checked if the averages given by the participants were over 3.5 or below 3.5 in both questionnaires. The result is that 86\% of pairs are symmetric when not considering the variance, 83\% when considering it, thus, we can confirm that naturally humans find similarity symmetric.\\
As a last remark, we computed the correlation between the personal data we have retrieved in the survey (i.e. age, sex) and the answers regarding scales and synonyms, but no significative correlation was found.
\section{Lesson Learned}
Our research is based on the quest of semantic similarity in the context of user reviews. This problem arises because people have different ways to express themselves and interpret what they read. Our aim is to allow semantic-related search for adjectives. We addressed this using tools to develop methods that find synonyms for adjectives. The first idea was to use a lexical database, \wordnet, for this purpose. According to our evaluation, the approach that yields the most results is the one that expands the most with synsets and \emphq{similar to}. The second tool we use is \spacy, a system that has pre-trained word-vector models. We used its largest model to find similarity using word vectors. Here, the approaches that performed better were the ones taking context into account.\\
To order these synonyms, we propose two different schemes: one treats all the synonyms of an adjective as equal, the other uses scales to order them. We introduce two different types of scales. One created with \sentiwordnet, with which we statically order the adjectives according to their polarity, and another using \wordvec, that is based on analogies and is created from a reference scale. 
Here we summarise our findings:
\begin{itemize}
	\item Lexical approaches perform well at finding synonyms, even if they do not find many, but cannot take context into account.
	\item Word vectors have the power to take context into account, even though they might miss some synonyms and cannot discover antonyms.
	\item The performance of the word-vector approaches depend heavily on the trained data, the threshold values and the ground truth for similarity. These values should be experimentally defined depending on the application domain. In our experience, vectors trained on larger corpus perform better and are more precise.
	\item The idea of learning scales has the potential to improve ranking of subjective content. We found out that lexical approaches and \wordvec are comparable for scale learning. But we can see that \wordvec allows to learn any scale without the need of complex supervised learning such as the one used by \sentiwordnet. Moreover, scales can be dynamically adapted according to the vocabulary used by \wordvec while \sentiwordnet provides static scales due to the static polarities assigned to words. 
\end{itemize}

